{% from "../error-message/macro.njk" import errorMessage -%}
{% from "../fieldset/macro.njk" import fieldset %}
{% from "../hint/macro.njk" import hint %}
{% from "../label/macro.njk" import label %}

{#- If an id 'prefix' is not passed, fall back to using the name attribute
   instead. We need this for error messages and hints as well -#}
{% set idPrefix = params.idPrefix if params.idPrefix else params.name %}

{#- a record of other elements that we need to associate with the input using
   aria-describedby – for example hints or error messages -#}
{% set describedBy = "" %}

{% set isConditional = false %}
{% for item in params.items %}
  {% if item.conditional.html %}
    {% set isConditional = true %}
  {% endif %}
{% endfor %}

{#- Capture the HTML so we can optionally nest it in a fieldset -#}
{% set innerHtml %}
{% if params.hint %}
  {% set hintId = idPrefix + '-hint' %}
  {% set describedBy = describedBy + ' ' + hintId if describedBy else hintId %}
  {{ hint({
    id: hintId,
    classes: params.hint.classes,
    attributes: params.hint.attributes,
    html: params.hint.html,
    text: params.hint.text
  }) | indent(2) | trim }}
{% endif %}
{%- if params.errorMessage %}
  {%- set errorId = idPrefix + '-error' %}
  {%- set describedBy = describedBy + ' ' + errorId if describedBy else errorId %}
  {{ errorMessage({
    id: errorId,
    classes: params.errorMessage.classes,
    html: params.errorMessage.html,
    text: params.errorMessage.text,
  locale: params.errorMessage.locale
}) | indent(2) | trim }}
{% endif %}
  <div class="nhsuk-radios
  {%- if params.classes %} {{ params.classes }}{% endif %} {%- if isConditional %} nhsuk-radios--conditional{% endif -%}"
  {%- for attribute, value in params.attributes %} {{ attribute }}="{{ value }}"{% endfor %}>
    {%- for item in params.items %}
    {%- set id = item.id if item.id else idPrefix + "-" + loop.index %}
    {% set conditionalId = "conditional-" + id %}
    {%- if item.divider %}
    <div class="nhsuk-radios__divider">{{ item.divider }}</div>
    {%- else %}
    {%- set hasHint = true if item.hint.text or item.hint.html %}
    {%- set itemHintId = id + '-item-hint' %}
    <div class="nhsuk-radios__item">
      <input class="nhsuk-radios__input" id="{{ id }}" name="{{ params.name }}" type="radio" value="{{ item.value }}"
      {{-" checked" if item.checked }}
      {{-" disabled" if item.disabled }}
      {%- if item.conditional.html %} aria-controls="{{ conditionalId }}" aria-expanded="{{"true" if item.checked else "false"}}"{% endif -%}
      {%- if hasHint %} aria-describedby="{{ itemHintId }}"{% endif -%}
      {%- for attribute, value in item.attributes %} {{ attribute }}="{{ value }}"{% endfor -%}>
      {{ label({
        html: item.html,
        text: item.text,
        locale: item.locale,
        classes: 'nhsuk-radios__label' + (' ' + item.label.classes if item.label.classes),
        attributes: item.label.attributes,
        for: id
      }) | indent(6) | trim }}
      {%- if hasHint %}
      {{ hint({
        id: itemHintId,
        classes: 'nhsuk-radios__hint',
        attributes: item.hint.attributes,
        html: item.hint.html,
        text: item.hint.text
      }) | indent(6) | trim }}
      {%- endif %}
    </div>
    {% if item.conditional.html %}
    <div class="nhsuk-radios__conditional{% if not item.checked %} nhsuk-radios__conditional--hidden{% endif %}" id="{{ conditionalId }}">
      {{ item.conditional.html | safe }}
    </div>
    {% endif %}
    {%- endif %}
    {%- endfor %}
  </div>
{% endset -%}

<div class="nhsuk-form-group {%- if params.errorMessage %} nhsuk-form-group--error{% endif %} {%- if params.formGroup.classes %} {{ params.formGroup.classes }}{% endif %}">
{% if params.fieldset %}
  {% call fieldset({
    describedBy: describedBy,
    classes: params.fieldset.classes,
    attributes: params.fieldset.attributes,
    legend: params.fieldset.legend
  }) %}
  {{ innerHtml | trim | safe }}
  {% endcall %}
{%- else %}
  {{ innerHtml | trim | safe }}
{%- endif %}
</div>